cdac.medinfo.sdk.hl7282.baselibs.segments

## Class AIS

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.AIS

- All Implemented Interfaces:
    ISegment

      public class AIS
      extends Segment

  AIS - Appointment Information-Service Segment.

  The AIS segment contains information about various kinds of services that can be scheduled. Services included in a transaction using this segment are assumed to be controlled by a schedule on a schedule filler application.

  Represents an HL7 AIS message segment. This segment has the following fields:

  AIS-1: Set ID - AIS (SI)Required
  AIS-2: Segment Action Code (ID)Conditional
  AIS-3: Universal Service Identifier (CWE)Required
  AIS-4: Start Date/Time (DTM)Conditional
  AIS-5: Start Date/Time Offset (NM)Conditional
  AIS-6: Start Date/Time Offset Units (CNE)Conditional
  AIS-7: Duration (NM)Optional
  AIS-8: Duration Units (CNE)Optional
  AIS-9: Allow Substitution Code (CWE)Conditional
  AIS-10: Filler Status Code (CWE)Conditional
  AIS-11: Placer Supplemental Service Information (CWE)Optional
  AIS-12: Filler Supplemental Service Information (CWE)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AIS()` Constructs the AIS segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addFillerSupplementalServiceInformation(CWE fillerSupplementalServiceInformation)` Add the Filler Supplemental Service Information.
    `void` | `addFillerSupplementalServiceInformation(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Filler Supplemental Service Information.
    `void` | `addPlacerSupplementalServiceInformation(CWE objplacerSupplementalServiceInformation)` Add the Placer Supplemental Service Information.
    `void` | `addPlacerSupplementalServiceInformation(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Placer Supplemental Service Information.
    `CWE` | `getAllowSubstitutionCode()` Retrieves the Allow Substitution Code.
    `NM` | `getDuration()` Retrieves the Duration.
    `CNE` | `getDurationUnits()` Retrieves the Duration Units.
    `CWE` | `getFillerStatusCode()` Retrieves the Filler Status Code.
    `ISingleCollection<CWE>` | `getFillerSupplementalServiceInformation()` Retrieves the Filler Supplemental Service Information.
    `ISingleCollection<CWE>` | `getPlacerSupplementalServiceInformation()` Retrieves the Placer Supplemental Service Information.
    `ID` | `getSegmentActionCode()` Retrieves the Segment Action Code.
    `SI` | `getSetID_AIS()` Retrieves the Set ID AIS.
    `DTM` | `getStartDateTime()` Retrieves the Start Date Time.
    `NM` | `getStartDateTimeOffset()` Retrieves the Start Date Time Offset.
    `CNE` | `getStartDateTimeOffsetUnits()` Retrieves the Start Date Time Offset Units.
    `CWE` | `getUniversalServiceIdentifier()` Retrieves the Universal Service Identifier.
    `void` | `setAllowSubstitutionCode(CWE objallowSubstitutionCode)` Set the Allow Substitution Code.
    `void` | `setAllowSubstitutionCode(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Allow Substitution Code.
    `void` | `setDuration(NM objduration)` Set the duration.
    `void` | `setDuration(java.lang.String strDuration)` Set the duration.
    `void` | `setDurationUnits(CNE objdurationUnits)` Set the Duration Units.
    `void` | `setDurationUnits(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Duration Units.
    `void` | `setFillerStatusCode(CWE objfillerStatusCode)` Set the Filler Status Code.
    `void` | `setFillerStatusCode(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Filler Status Code.
    `void` | `setFillerSupplementalServiceInformation(ISingleCollection<CWE> fillerSupplementalServiceInformationList)` Set the Filler Supplemental Service Information.
    `void` | `setPlacerSupplementalServiceInformation(ISingleCollection<CWE> objplacerSupplementalServiceInformationList)` Set the Placer Supplemental Service Information.
    `void` | `setSegmentActionCode(ID objsegmentActionCode)` Set the Segment Action Code.
    `void` | `setSegmentActionCode(java.lang.String strSegmentActionCode)` Set the Segment Action Code.
    `void` | `setSetID_AIS(SI objsetID_AIS)` Set the Set ID AIS.
    `void` | `setSetID_AIS(java.lang.String strSetID_AIS)` Set the Set ID AIS.
    `void` | `setStartDateTime(DTM objstartDateTime)` Set the Start Date Time.
    `void` | `setStartDateTime(java.lang.String strTime)` Set the Start Date Time.
    `void` | `setStartDateTimeOffset(NM objstartDateTimeOffset)` Set the Start Date Time Offset.
    `void` | `setStartDateTimeOffset(java.lang.String strStartDateTimeOffset)` Set the Start Date Time Offset.
    `void` | `setStartDateTimeOffsetUnits(CNE objstartDateTimeOffsetUnits)` Set the Start Date Time Offset Units.
    `void` | `setStartDateTimeOffsetUnits(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Start Date Time Offset Units.
    `void` | `setUniversalServiceIdentifier(CWE objuniversalServiceIdentifier)` Set the Universal Service Identifier.
    `void` | `setUniversalServiceIdentifier(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Universal Service Identifier.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AIS

          public AIS()

      Constructs the AIS segment.

  - ### Method Detail

    - #### getAllowSubstitutionCode

          public CWE getAllowSubstitutionCode()

      Retrieves the Allow Substitution Code. This field specify the code which indicating whether the identified resource can be substituted with an equivalent resource by the filler application or not.
      Returns:
        CWE - allowSubstitutionCode

    - #### getDuration

          public NM getDuration()

      Retrieves the Duration. This field specify the duration for which the resource is requested/scheduled for this appointment, if different from the overall duration of the requested/scheduled appointment. Expressed in units of time relative to the scheduled start date/time.
      Returns:
        NM - duration

    - #### getDurationUnits

          public CNE getDurationUnits()

      Retrieves the Duration Units. This field specify the code which describing the units of time used for expressing the duration.
      Returns:
        CNE - durationUnits

    - #### getFillerStatusCode

          public CWE getFillerStatusCode()

      Retrieves the Filler Status Code. This field specify the code which describes the requested/scheduled status of the resource or activity, from the point of view of the filler application.
      Returns:
        CWE - fillerStatusCode

    - #### getFillerSupplementalServiceInformation

          public ISingleCollection<CWE> getFillerSupplementalServiceInformation()

      Retrieves the Filler Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the filler system to the placer system for the procedure code reported in field AIS-3.
      Returns:
        ISingleCollection - fillerSupplementalServiceInformation

    - #### getPlacerSupplementalServiceInformation

          public ISingleCollection<CWE> getPlacerSupplementalServiceInformation()

      Retrieves the Placer Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the placer system to the filler system for the universal procedure code reported in field AIS-3.
      Returns:
        ISingleCollection - placerSupplementalServiceInformation

    - #### getSegmentActionCode

          public ID getSegmentActionCode()

      Retrieves the Segment Action Code. This field specify the action to be taken when updating or modifying information in this segment from previously sent interface transactions.
      Returns:
        ID - segmentActionCode

    - #### getSetID_AIS

          public SI getSetID_AIS()

      Retrieves the Set ID AIS.
      Returns:
        SI - setID_AIS

    - #### getStartDateTime

          public DTM getStartDateTime()

      Retrieves the Start Date Time. This field specify the date and time that service needs for the appointment.
      Returns:
        DTM - startDateTime

    - #### getStartDateTimeOffset

          public NM getStartDateTimeOffset()

      Retrieves the Start Date Time Offset. This field specify the offset that service needs for the appointment, expressed in units of time relative to the scheduled start date/time.
      Returns:
        NM - startDateTimeOffset

    - #### getStartDateTimeOffsetUnits

          public CNE getStartDateTimeOffsetUnits()

      Retrieves the Start Date Time Offset Units. This field specify the code which describing the units of time used for expressing the start date/time offset.
      Returns:
        CNE - startDateTimeOffsetUnits

    - #### getUniversalServiceIdentifier

          public CWE getUniversalServiceIdentifier()

      Retrieves the Universal Service Identifier. This field specify an identifier code for a service to be scheduled.
      Returns:
        CWE - universalServiceIdentifier

    - #### setSetID_AIS

          public void setSetID_AIS(java.lang.String strSetID_AIS)

      Set the Set ID AIS.
      Parameters:
        `strSetID_AIS` - This field contains the number that identifies AIS transaction.

    - #### setSetID_AIS

          public void setSetID_AIS(SI objsetID_AIS)

      Set the Set ID AIS.
      Parameters:
        `objsetID_AIS` - Object of Set ID AIS.

    - #### setSegmentActionCode

          public void setSegmentActionCode(java.lang.String strSegmentActionCode)

      Set the Segment Action Code. This field specify the action to be taken when updating or modifying information in this segment from previously sent interface transactions.
      Parameters:
        `strSegmentActionCode` - String shows the action to be taken .

    - #### setSegmentActionCode

          public void setSegmentActionCode(ID objsegmentActionCode)

      Set the Segment Action Code. This field specify the action to be taken when updating or modifying information in this segment from previously sent interface transactions.
      Parameters:
        `objsegmentActionCode` - Object of Segment Action Code.

    - #### setUniversalServiceIdentifier

          public void setUniversalServiceIdentifier(java.lang.String strIdentifier,
                                           java.lang.String strText,
                                           java.lang.String strNameOfCodingSystem,
                                           java.lang.String strAlternateIdentifier,
                                           java.lang.String strAlternateText,
                                           java.lang.String strNameOfAlternateCodingSystem,
                                           java.lang.String strCodingSystemVersionID,
                                           java.lang.String strAlternateCodingSystemVersionId,
                                           java.lang.String strOriginalText,
                                           java.lang.String strSecondAlternateIdentifier,
                                           java.lang.String strSecondAlternateText,
                                           java.lang.String strNameofSecondAlternateCodingSystem,
                                           java.lang.String strSecondAlternateCodingSystemVersionID,
                                           java.lang.String strCodingSystemOID,
                                           java.lang.String strValueSetOID,
                                           java.lang.String strValueSetVersionID,
                                           java.lang.String strAlternateCodingSystemOID,
                                           java.lang.String strAlternateValueSetOID,
                                           java.lang.String strAlternateValueSetVersionID,
                                           java.lang.String strSecondAlternateCodingSystemOID,
                                           java.lang.String strSecondAlternateValueSetOID,
                                           java.lang.String strSecondAlternateValueSetVersionID)

      Set the Universal Service Identifier. This field specify an identifier code for a service to be scheduled.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setUniversalServiceIdentifier

          public void setUniversalServiceIdentifier(CWE objuniversalServiceIdentifier)

      Set the Universal Service Identifier. This field specify an identifier code for a service to be scheduled.
      Parameters:
        `objuniversalServiceIdentifier` - Object of Universal Service Identifier.

    - #### setStartDateTime

          public void setStartDateTime(java.lang.String strTime)

      Set the Start Date Time. This field specify the date and time that service needs for the appointment.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setStartDateTime

          public void setStartDateTime(DTM objstartDateTime)

      Set the Start Date Time. This field specify the date and time that service needs for the appointment.
      Parameters:
        `objstartDateTime` - Object of Start Date Time.

    - #### setStartDateTimeOffset

          public void setStartDateTimeOffset(java.lang.String strStartDateTimeOffset)

      Set the Start Date Time Offset. This field specify the offset that service needs for the appointment, expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `strStartDateTimeOffset` - Amount of time being requested for the appointment. .

    - #### setStartDateTimeOffset

          public void setStartDateTimeOffset(NM objstartDateTimeOffset)

      Set the Start Date Time Offset. This field specify the offset that service needs for the appointment, expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `objstartDateTimeOffset` - Object of

    - #### setStartDateTimeOffsetUnits

          public void setStartDateTimeOffsetUnits(java.lang.String strIdentifier,
                                         java.lang.String strText,
                                         java.lang.String strNameOfCodingSystem,
                                         java.lang.String strAlternateIdentifier,
                                         java.lang.String strAlternateText,
                                         java.lang.String strNameOfAlternateCodingSystem,
                                         java.lang.String strCodingSystemVersionID,
                                         java.lang.String strAlternateCodingSystemVersionID,
                                         java.lang.String strOriginalText,
                                         java.lang.String strSecondAlternateIdentifier,
                                         java.lang.String strSecondAlternateText,
                                         java.lang.String strNameOfSecondAltenateCodingSystem,
                                         java.lang.String strSecondAlternateCodingSystemVersionID,
                                         java.lang.String strCodingSystemOID,
                                         java.lang.String strValueSetOID,
                                         java.lang.String strValueSetVersionID,
                                         java.lang.String strAlternateCodingSystemOID,
                                         java.lang.String strAlternateValueSetOID,
                                         java.lang.String strAlternateValueSetVersionID,
                                         java.lang.String strSecondAlternateCodingSystemOID,
                                         java.lang.String strSecondAlternateValueSetOID,
                                         java.lang.String strSecondAlternateValueSetVersionID)

      Set the Start Date Time Offset Units. This field specify the code which describing the units of time used for expressing the start date/time offset.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setStartDateTimeOffsetUnits

          public void setStartDateTimeOffsetUnits(CNE objstartDateTimeOffsetUnits)

      Set the Start Date Time Offset Units. This field specify the code which describing the units of time used for expressing the start date/time offset.
      Parameters:
        `objstartDateTimeOffsetUnits` - Object of Start Date Time Offset Units.

    - #### setDuration

          public void setDuration(java.lang.String strDuration)

      Set the duration. This field specify the duration for which the resource is requested/scheduled for this appointment, if different from the overall duration of the requested/scheduled appointment. Expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `strDuration` - Amount of time being requested for the appointment. .

    - #### setDuration

          public void setDuration(NM objduration)

      Set the duration. This field specify the duration for which the resource is requested/scheduled for this appointment, if different from the overall duration of the requested/scheduled appointment. Expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `objduration` - Object of duration.

    - #### setDurationUnits

          public void setDurationUnits(java.lang.String strIdentifier,
                              java.lang.String strText,
                              java.lang.String strNameOfCodingSystem,
                              java.lang.String strAlternateIdentifier,
                              java.lang.String strAlternateText,
                              java.lang.String strNameOfAlternateCodingSystem,
                              java.lang.String strCodingSystemVersionID,
                              java.lang.String strAlternateCodingSystemVersionID,
                              java.lang.String strOriginalText,
                              java.lang.String strSecondAlternateIdentifier,
                              java.lang.String strSecondAlternateText,
                              java.lang.String strNameOfSecondAltenateCodingSystem,
                              java.lang.String strSecondAlternateCodingSystemVersionID,
                              java.lang.String strCodingSystemOID,
                              java.lang.String strValueSetOID,
                              java.lang.String strValueSetVersionID,
                              java.lang.String strAlternateCodingSystemOID,
                              java.lang.String strAlternateValueSetOID,
                              java.lang.String strAlternateValueSetVersionID,
                              java.lang.String strSecondAlternateCodingSystemOID,
                              java.lang.String strSecondAlternateValueSetOID,
                              java.lang.String strSecondAlternateValueSetVersionID)

      Set the Duration Units. This field specify the code which describing the units of time used for expressing the duration.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setDurationUnits

          public void setDurationUnits(CNE objdurationUnits)

      Set the Duration Units. This field specify the code which describing the units of time used for expressing the duration.
      Parameters:
        `objdurationUnits` - Object of Duration Units.

    - #### setAllowSubstitutionCode

          public void setAllowSubstitutionCode(java.lang.String strIdentifier,
                                      java.lang.String strText,
                                      java.lang.String strNameOfCodingSystem,
                                      java.lang.String strAlternateIdentifier,
                                      java.lang.String strAlternateText,
                                      java.lang.String strNameOfAlternateCodingSystem,
                                      java.lang.String strCodingSystemVersionID,
                                      java.lang.String strAlternateCodingSystemVersionId,
                                      java.lang.String strOriginalText,
                                      java.lang.String strSecondAlternateIdentifier,
                                      java.lang.String strSecondAlternateText,
                                      java.lang.String strNameofSecondAlternateCodingSystem,
                                      java.lang.String strSecondAlternateCodingSystemVersionID,
                                      java.lang.String strCodingSystemOID,
                                      java.lang.String strValueSetOID,
                                      java.lang.String strValueSetVersionID,
                                      java.lang.String strAlternateCodingSystemOID,
                                      java.lang.String strAlternateValueSetOID,
                                      java.lang.String strAlternateValueSetVersionID,
                                      java.lang.String strSecondAlternateCodingSystemOID,
                                      java.lang.String strSecondAlternateValueSetOID,
                                      java.lang.String strSecondAlternateValueSetVersionID)

      Set the Allow Substitution Code. This field specify the code which indicating whether the identified resource can be substituted with an equivalent resource by the filler application or not.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setAllowSubstitutionCode

          public void setAllowSubstitutionCode(CWE objallowSubstitutionCode)

      Set the Allow Substitution Code. This field specify the code which indicating whether the identified resource can be substituted with an equivalent resource by the filler application or not.
      Parameters:
        `objallowSubstitutionCode` - Object of Allow Substitution Code.

    - #### setFillerStatusCode

          public void setFillerStatusCode(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Filler Status Code. This field specify the code which describes the requested/scheduled status of the resource or activity, from the point of view of the filler application.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setFillerStatusCode

          public void setFillerStatusCode(CWE objfillerStatusCode)

      Set the Filler Status Code. This field specify the code which describes the requested/scheduled status of the resource or activity, from the point of view of the filler application.
      Parameters:
        `objfillerStatusCode` - object of Filler Status Code.

    - #### addPlacerSupplementalServiceInformation

          public void addPlacerSupplementalServiceInformation(java.lang.String strIdentifier,
                                                     java.lang.String strText,
                                                     java.lang.String strNameOfCodingSystem,
                                                     java.lang.String strAlternateIdentifier,
                                                     java.lang.String strAlternateText,
                                                     java.lang.String strNameOfAlternateCodingSystem,
                                                     java.lang.String strCodingSystemVersionID,
                                                     java.lang.String strAlternateCodingSystemVersionId,
                                                     java.lang.String strOriginalText,
                                                     java.lang.String strSecondAlternateIdentifier,
                                                     java.lang.String strSecondAlternateText,
                                                     java.lang.String strNameofSecondAlternateCodingSystem,
                                                     java.lang.String strSecondAlternateCodingSystemVersionID,
                                                     java.lang.String strCodingSystemOID,
                                                     java.lang.String strValueSetOID,
                                                     java.lang.String strValueSetVersionID,
                                                     java.lang.String strAlternateCodingSystemOID,
                                                     java.lang.String strAlternateValueSetOID,
                                                     java.lang.String strAlternateValueSetVersionID,
                                                     java.lang.String strSecondAlternateCodingSystemOID,
                                                     java.lang.String strSecondAlternateValueSetOID,
                                                     java.lang.String strSecondAlternateValueSetVersionID)

      Add the Placer Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the placer system to the filler system for the universal procedure code reported in field AIS-3.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addPlacerSupplementalServiceInformation

          public void addPlacerSupplementalServiceInformation(CWE objplacerSupplementalServiceInformation)

      Add the Placer Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the placer system to the filler system for the universal procedure code reported in field AIS-3.
      Parameters:
        `objplacerSupplementalServiceInformation` - Object of Placer Supplemental Service Information.

    - #### setPlacerSupplementalServiceInformation

          public void setPlacerSupplementalServiceInformation(ISingleCollection<CWE> objplacerSupplementalServiceInformationList)

      Set the Placer Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the placer system to the filler system for the universal procedure code reported in field AIS-3.
      Parameters:
        `objplacerSupplementalServiceInformationList` - List of Placer Supplemental Service Information.

    - #### addFillerSupplementalServiceInformation

          public void addFillerSupplementalServiceInformation(java.lang.String strIdentifier,
                                                     java.lang.String strText,
                                                     java.lang.String strNameOfCodingSystem,
                                                     java.lang.String strAlternateIdentifier,
                                                     java.lang.String strAlternateText,
                                                     java.lang.String strNameOfAlternateCodingSystem,
                                                     java.lang.String strCodingSystemVersionID,
                                                     java.lang.String strAlternateCodingSystemVersionId,
                                                     java.lang.String strOriginalText,
                                                     java.lang.String strSecondAlternateIdentifier,
                                                     java.lang.String strSecondAlternateText,
                                                     java.lang.String strNameofSecondAlternateCodingSystem,
                                                     java.lang.String strSecondAlternateCodingSystemVersionID,
                                                     java.lang.String strCodingSystemOID,
                                                     java.lang.String strValueSetOID,
                                                     java.lang.String strValueSetVersionID,
                                                     java.lang.String strAlternateCodingSystemOID,
                                                     java.lang.String strAlternateValueSetOID,
                                                     java.lang.String strAlternateValueSetVersionID,
                                                     java.lang.String strSecondAlternateCodingSystemOID,
                                                     java.lang.String strSecondAlternateValueSetOID,
                                                     java.lang.String strSecondAlternateValueSetVersionID)

      Add the Filler Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the filler system to the placer system for the procedure code reported in field AIS-3.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addFillerSupplementalServiceInformation

          public void addFillerSupplementalServiceInformation(CWE fillerSupplementalServiceInformation)

      Add the Filler Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the filler system to the placer system for the procedure code reported in field AIS-3.
      Parameters:
        `fillerSupplementalServiceInformation` - Object of Filler Supplemental Service Information.

    - #### setFillerSupplementalServiceInformation

          public void setFillerSupplementalServiceInformation(ISingleCollection<CWE> fillerSupplementalServiceInformationList)

      Set the Filler Supplemental Service Information. This field specify the supplemental service and/or logistical information sent from the filler system to the placer system for the procedure code reported in field AIS-3.
      Parameters:
        `fillerSupplementalServiceInformationList` - List of Filler Supplemental Service Information.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Thrown when Segment Validation Fails.